#include <iostream>
#include <vector>

using namespace std;

const int P=8000000;

void f(vector<int>& x,int n)
{
    for(int i=1; i<n; i++)
    {
        if(x[i-1]>0)
        {
            x[i]+=x[i-1]-1;
        }
        else
        {
            x[i]=x[i];
        }
    }
    for(int i=0; i<n; i++)
    {
        if(x[i]>0)
        {
            x[i]=1;
        }
    }
    for(int i=1; i<n; i++)
    {
        x[i]+=x[i-1];
    }
}

int main()
{
    int n,q,p,k,d;
    cin>>n>>q;
    vector<int> r(P,0);

    if(q>1)
    {
        for(int i=0; i<n; i++)
        {
            cin>>d>>p;
            r[d]+=p;
        }
        f(r,P);
        for(int i=0; i<q; i++)
        {
            cin>>k;
            cout<<r[k]<<endl;
        }
    }
    else
    {
        for(int i=0; i<n; i++)
        {
            cin>>d>>p;
            r[d]+=p;
        }
        cin>>k;
        f(r,k+1);
        r[k];
    }
    return 0;
}